UR::Object::Tag(3pm)

NAME
UR::Object::Tag - Transitory attribute tags for a UR::Object at a given time.

SYNOPSIS
  if (my @attribs = grep { $_->type eq 'invalid' } $obj->attribs()) {
      print $obj->display_name . " has invalid attributes.  They are:\n";
      for my $atrib (@attribs) {
          print join(",",$attrib->properties) . ":" . $attrib->desc . "\n";
      }
  }

  Project H_NHF00 has invalid attributes, they are:
  project_subdirectory : Directory does not exist.
  target, status : Target cannot be null for projects with an active status.

DESCRIPTION
Objects of this class are created by create_attribs() on classes derived from UR::Object. They are retrieved by UR::Object->attribs().

INHERITANCE
This class inherits from UR::ModuleBase.

OBJECT METHODS

type
    A single-word description of the attribute which categorizes the attribute. Common attribute types are:

    invalid
        Set when the object has invalid properties and cannot be saved.

    changed
        Set when the object is different than its "saved" version.

    hidden
        Set when the object has properties which should not be shown.

    editable
        Set when some part of the object is editable in the current context.

    warning
        Set when a warning about the state of the object is in effect.

    match
        Set when a search which is in effect matches this object's property(s).

    comment
        Set when this attribute is just an informational message.

properties
    A list of properties to which the attribute applies. This is null when the attribute applies to the whole object, but typically returns one property name. Occasionally, it returns more than one property. Very rarely (currently never), the property may be in the form of an arrayref like: [ class_name, id, property_name ], in which case the property may actually be that of another related object.

desc
    A string of text giving detail to the attribute.

CLASS METHODS

create
    Makes a new UR::Object::Tag.

delete
    Throws one away.

filter
    Sets/gets a filter to be applied to all attribute lists returned in the application. This gives the application developer final veto power over expressed attributes in the app. In most cases, developers will write view components which use attributes, and will ignore them rather than plug-in at this low level to augment/mangle/supress.

    The filter will be given an object reference and a reference to an array of attributes which are tentatively to be delivered for the object.

SEE ALSO
UR::Object(3)